﻿@page
@model IndexModel
@{
    ViewData["Title"] = "Home page";
}
<style>
    #miDiv{
        position:absolute;
        z-index:9;
        background-color: #f1f1f1;
        border: 1px solid #d3d3d3;
        text-align: center;
    }
    #miDivCursor{
        padding: 10px;
        cursor: move;
        z-index:10;
        background-color:#2196F3;
        color: #fff;
    }
     .container {
            width: 400px;
            margin: 0 auto;

        }

        .my-div {
          width: 600px;
          height: 350px;
          background-color: #eaeaea;
          border-radius: 10px;
          box-shadow: 0 0 10px rgba(0, 0, 0, 0.3);
          position: relative;
          transform-style: preserve-3d;
          perspective: 800px;
          margin:10px auto;
        }


        .message-input {
            width: 100%;
            height: 40px;
            padding: 5px;
            font-size: 16px;
            border: 1px solid #ccc;
            border-radius: 4px;
            box-sizing: border-box;
            margin-bottom: 10px;
        }
        .user-input {
            width: 50%;
            height: 40px;
            padding: 5px;
            font-size: 16px;
            border: 1px solid #ccc;
            border-radius: 4px;
            box-sizing: border-box;
            margin-bottom: 10px;
        }

        .message-display {
            width: 100%;
            min-height: 200px;
            padding: 10px;
            border: 1px solid #ccc;
            border-radius: 4px;
            overflow-y: auto;
            font-size: 16px;
        }
</style>
 
@*<div id="miDiv">
    <div id="miDivCursor">Click y mueveme</div>
</div>
<br />
<br />*@
<div class="my-div">
         <input type="text" class="user-input" id="room-input" value="Sala 1" disabled>
         <input type="text" class="user-input" id="user-input1" placeholder="Quien escribe">
        <input type="text" class="message-input" id="messageInput1" data-room=1 placeholder="Escribe un mensaje...">
        <div class="message-display" id="messageDisplay1"></div>
    </div>
    <div class="my-div">
         <input type="text" class="user-input" id="room-input2" placeholder="Sala 2" disabled>
         <input type="text" class="user-input" id="user-input2" placeholder="Quien escribe">
        <input type="text" class="message-input" id="messageInput2" data-room=2 placeholder="Escribe un mensaje...">
        <div class="message-display" id="messageDisplay2"></div>
    </div>



    <script src="~/lib/microsoft/signalr/dist/browser/signalr.js"></script> 
 <script>

//     //es la parte donde se establece la conexion del servidor con el cliente
//     // , es la encargada de empezar o identificar el Hub que va enviar o recibir
//     var connection = new signalR.HubConnectionBuilder()
//     .withUrl("/positionHub")
//     .build();

//     dragElement(document.getElementById("miDiv"));

//    function dragElement(elmnt) {
//        var pos1 = 0, pos2 = 0, pos3 = 0, pos4 = 0;
//             document.getElementById(elmnt.id + "Cursor").onmousedown = dragMouseDown;
     
//    function dragMouseDown(e) {
//        e = e || window.event;
//        e.preventDefault();
//        // obtenemos posición de mouse
//        pos3 = e.clientX;
//        pos4 = e.clientY;
//        document.onmouseup = closeDragElement;

//        // llama función para darle posición nueva al div
//        document.onmousemove = elementDrag;
//    }

//    function elementDrag(e) {
//        e = e || window.event;
//        e.preventDefault();
//        // calcula la nueva posición del cursor
//        pos1 = pos3 - e.clientX;
//        pos2 = pos4 - e.clientY;
//        pos3 = e.clientX;
//        pos4 = e.clientY;
//        // asignamos el movimiento
//        elmnt.style.top = (elmnt.offsetTop - pos2) + "px";
//        elmnt.style.left = (elmnt.offsetLeft - pos1) + "px";

//        //envio de mensaje a los otros que no soy yo
//        connection.invoke("SendPosition",
//                            elmnt.offsetLeft - pos1,elmnt.offsetTop - pos2)
//                            .catch( err => console.log(err))
         
//    }

//    function closeDragElement() {
//        // detiene movimiento cuando mouse deja de moverse
//        document.onmouseup = null;
//        document.onmousemove = null;

//    }
//}
 

//    connection.on("ReceivePosition",
//       (left,top) => {
//           document.getElementById("miDiv").style.top = top +"px";
//           document.getElementById("miDiv").style.left = left +"px";
//       })
//       ;

//    connection.start().then(
//       function(){
//           console.log("conectado");
//       }
//    );

      var connectionChat = new signalR.HubConnectionBuilder()
     .withUrl("/notificacionHub")
     .build();

       var messageInput = document.getElementsByClassName('message-input');

       // Agregar un controlador de eventos a cada elemento
        for (var i = 0; i < messageInput.length; i++) {
          messageInput[i].addEventListener("keypress", function(e) {
            // Obtener el nombre de la ID del elemento actual
            var room =this.getAttribute('data-room');
            var messageDisplay = document.getElementById("messageDisplay"+room);   
            var userInput = document.getElementById("user-input"+room);
            if(userInput.value!=''){
                if (e.key === 'Enter') {
                    var message = this.value;
                    messageInput.value = '';

                    var messageElement = document.createElement('p');
                    messageElement.textContent ="Yo: "+ message;

                    messageDisplay.appendChild(messageElement);
                     //envio de mensaje a los otros que no soy yo
                     connectionChat.invoke("SendNotificacion",room,userInput.value,
                                message)
                                .catch( err => console.log(err))
                   this.value='';
                   
                }
            }
           
          });
        }


         connectionChat.on("ReceiveNotificacion",
       (room,user,message) => {
                var messageDisplay = document.getElementById("messageDisplay"+room);   
                messageInput.value = '';
                var messageElement = document.createElement('p');
                messageElement.textContent = user + " : " +message;
                messageDisplay.appendChild(messageElement);
                 
       })
       ;

    connectionChat.start().then(
       function(){
           console.log("conectado");
       }
    );

    </script>
